<?
include "init.php";

// ################# Start getting Youtube GData ##############################

$user_data           = YT_GetUserProfile($_GET['u']);
$user_upload_list    = YT_GetUserUpload($_GET['u'], 1, $config['user_uploaded_list_per_page']);
$user_favorites_list = YT_GetUserFavorites($_GET['u'], 1, $config['user_favorites_list_per_page']);

// ################# Start parse xml attributes manually ######################

preg_match_all('/<[^>]+>/s',$user_data[1],$tags);

foreach ($tags[0] as $k => $v) {

  $v = str_replace('"',"\'",$v);

  if (substr($v, 0, 16) == '<media:thumbnail') {
    preg_match("/url='(.*)'/i", $v, $matches);
    $thumbnail = $matches[1];
  }

  if (substr($v, 0, 14) == '<yt:statistics') {
    preg_match("/viewCount='([0-9]*)'/i", $v, $matches);
    $view_count = $matches[1];
    preg_match("/subscriberCount='([0-9]*)'/i", $v, $matches);
    $subscriber_count = $matches[1];
    preg_match("/videoWatchCount='([0-9]*)'/i", $v, $matches);
    $view_watch_count = $matches[1];
    preg_match("/lastWebAccess='(.*)'/i", $v, $matches);
    $last_web_access = $matches[1];
  }

  if (substr($v, 0, 12) == '<gd:feedLink') {
    preg_match("/favorites' countHint='(.*)'/i", $v, $matches);
    if(empty($favorites_count)) $favorites_count = $matches[1];
    preg_match("/contacts' countHint='(.*)'/i", $v, $matches);
    if(empty($contacts_count)) $contacts_count = $matches[1];
    preg_match("/subscriptions' countHint='(.*)'/i", $v, $matches);
    if(empty($subscriptions_count)) $subscriptions_count = $matches[1];
  }
}

preg_match_all('/<[^>]+>/s',$user_upload_list[1],$tags);

$i=0;
foreach ($tags[0] as $k => $v) {

  $v = str_replace('"',"\'",$v);

  if (substr($v, 0, 12) == '<yt:duration') {
    preg_match("/seconds='(.*)'/i", $v, $matches);
    $user_upload_list[0][entry][$i][duration] = $matches[1];
  }

  if (substr($v, 0, 14) == '<yt:statistics') {
    preg_match("/viewCount='(.*)'/i", $v, $matches);
    $user_upload_list[0][entry][$i][view_count] = $matches[1];
  }

  if (substr($v, 0, 10) == '<gd:rating') {
    preg_match("/numRaters='(.*)' average/i", $v, $matches);
    $user_upload_list[0][entry][$i][rating_num_raters] = $matches[1];

    preg_match("/average='(.*)'/i", $v, $matches);
    $user_upload_list[0][entry][$i][rating_average] = $matches[1];
  }

  if (substr($v, 0, 7) == '</entry') {
    $i++;
  }
}

preg_match_all('/<[^>]+>/s',$user_favorites_list[1],$tags);

$i=0;
foreach ($tags[0] as $k => $v) {

  $v = str_replace('"',"\'",$v);

  if (substr($v, 0, 12) == '<yt:duration') {
    preg_match("/seconds='(.*)'/i", $v, $matches);
    $user_favorites_list[0][entry][$i][duration] = $matches[1];
  }

  if (substr($v, 0, 14) == '<yt:statistics') {
    preg_match("/viewCount='(.*)'/i", $v, $matches);
    $user_favorites_list[0][entry][$i][view_count] = $matches[1];
  }

  if (substr($v, 0, 10) == '<gd:rating') {
    preg_match("/numRaters='(.*)' average/i", $v, $matches);
    $user_favorites_list[0][entry][$i][rating_num_raters] = $matches[1];

    preg_match("/average='(.*)'/i", $v, $matches);
    $user_favorites_list[0][entry][$i][rating_average] = $matches[1];
  }

  if (substr($v, 0, 7) == '</entry') {
    $i++;
  }
}

// ################# Start construct video data ###############################

if(is_array($user_upload_list[0][entry])) {
  foreach($user_upload_list[0][entry] as $k => $v) {
    $id_raw = explode('/',$user_upload_list[0][entry][$k][id]);

    $user_upload_list[0][entry][$k][id]           = array_pop($id_raw);
    $user_upload_list[0][entry][$k][author]       = $user_upload_list[0][entry][$k][author][0][name];
    $user_upload_list[0][entry][$k][description]  = $user_upload_list[0][entry][$k]['media:group'][0]['media:description'];
    $user_upload_list[0][entry][$k][category]     = $user_upload_list[0][entry][$k]['media:group'][0]['media:category'];
    $user_upload_list[0][entry][$k][thumbnail][0] = "http://img.youtube.com/vi/" . $user_upload_list[0][entry][$k][id] . "/0.jpg";
    $user_upload_list[0][entry][$k][thumbnail][1] = "http://img.youtube.com/vi/" . $user_upload_list[0][entry][$k][id] . "/1.jpg";
    $user_upload_list[0][entry][$k][thumbnail][2] = "http://img.youtube.com/vi/" . $user_upload_list[0][entry][$k][id] . "/2.jpg";
    $user_upload_list[0][entry][$k][thumbnail][3] = "http://img.youtube.com/vi/" . $user_upload_list[0][entry][$k][id] . "/3.jpg";

    $keywords_raw = explode(',',$user_upload_list[0][entry][$k]['media:group'][0]['media:keywords']);

    $i=0;
      foreach($keywords_raw as $k2 => $v2) {
      $user_upload_list[0][entry][$k][keywords][$i] = trim($v2);
      $i++;
    }  
  }
}

if(is_array($user_favorites_list[0][entry])) {
  foreach($user_favorites_list[0][entry] as $k => $v) {
    $id_raw = explode('/',$user_favorites_list[0][entry][$k][id]);

    $user_favorites_list[0][entry][$k][id]           = array_pop($id_raw);
    $user_favorites_list[0][entry][$k][author]       = $user_favorites_list[0][entry][$k][author][0][name];
    $user_favorites_list[0][entry][$k][description]  = $user_favorites_list[0][entry][$k]['media:group'][0]['media:description'];
    $user_favorites_list[0][entry][$k][category]     = $user_favorites_list[0][entry][$k]['media:group'][0]['media:category'];
    $user_favorites_list[0][entry][$k][thumbnail][0] = "http://img.youtube.com/vi/" . $user_favorites_list[0][entry][$k][id] . "/0.jpg";
    $user_favorites_list[0][entry][$k][thumbnail][1] = "http://img.youtube.com/vi/" . $user_favorites_list[0][entry][$k][id] . "/1.jpg";
    $user_favorites_list[0][entry][$k][thumbnail][2] = "http://img.youtube.com/vi/" . $user_favorites_list[0][entry][$k][id] . "/2.jpg";
    $user_favorites_list[0][entry][$k][thumbnail][3] = "http://img.youtube.com/vi/" . $user_favorites_list[0][entry][$k][id] . "/3.jpg";
  
    $keywords_raw = explode(',',$user_favorites_list[0][entry][$k]['media:group'][0]['media:keywords']);

    $i=0;
    foreach($keywords_raw as $k2 => $v2) {
      $user_favorites_list[0][entry][$k][keywords][$i] = trim($v2);
      $i++;
    }  
  }
}

if ($user_data[0]['yt:gender']=='m') $gender = 'Male';
elseif ($user_data[0]['yt:gender']=='f') $gender = 'Female';

if(empty($favorites_count)) {
  $favorites_count = 0;
}

// ################# Start assign template variables ##########################
       
$tpl->assign('join_date',$user_data[0][published]);
$tpl->assign('title',$user_data[0][title]);
$tpl->assign('name',$user_data[0][author][0][name]);
$tpl->assign('username',$user_data[0]['yt:username']);
$tpl->assign('books',$user_data[0]['yt:books']);
$tpl->assign('gender',$gender);
$tpl->assign('hobbies',$user_data[0]['yt:hobbies']);
$tpl->assign('location',$user_data[0]['yt:location']);
$tpl->assign('movies',$user_data[0]['yt:movies']);
$tpl->assign('music',$user_data[0]['yt:music']);
$tpl->assign('description',$user_data[0]['yt:description']);
$tpl->assign('hometown',$user_data[0]['yt:hometown']);
$tpl->assign('thumbnail',$thumbnail);
$tpl->assign('view_count',$view_count);
$tpl->assign('subscriber_count',$subscriber_count);
$tpl->assign('view_watch_count',$view_watch_count);
$tpl->assign('last_web_access',$last_web_access);
$tpl->assign('favorites_count',$favorites_count);
$tpl->assign('contacts_count',$contacts_count);
$tpl->assign('subscriptions_count',$subscriptions_count);
$tpl->assign('upload_count',$user_upload_list[0]['opensearch:totalresults']);
$tpl->assign('user_upload',$user_upload_list[0][entry]);
$tpl->assign('user_favorites',$user_favorites_list[0][entry]);
$tpl->display('user_profile.html');
?>